
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] rmp400Install] >= 0 } {
    interp expose {} rmp400Install
}

proc ::rmp400Install { name } {
    foreach rqst { "Init" "SetCmdParam" "SetKinematicsParam" "SetVarParam" "Stop" "JoystickOn" "Track" "SetPom" "SetPos" "Gyro" "GetGyro" "SetOdometryMethod" "SetWheelSizeCorrection" "Log" "StopLog" "LogInternalData" "StopInternalDataLog" "Goto" "MEPosmePosPosterRead" "OdoRobotPosterRead" "OdoVarPosterRead" "OdoRobot3dPosterRead" "RefrefPosterRead" "StatusstatusPosterRead" "StatusGenericstatusgenPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} rmp400$rqst $name
    }
}

interp hide {} rmp400Install




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400Init] >= 0 } {
    interp expose {} rmp400Init
}
if { [lsearch [interp hidden] rmp400InitFormatOutput] >= 0 } {
    interp expose {} rmp400InitFormatOutput
}

proc ::rmp400Init { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Init" \
	"Connect to USB bus" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp400InitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400Init
interp hide {} rmp400InitFormatOutput





# SetCmdParam ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400SetCmdParam] >= 0 } {
    interp expose {} rmp400SetCmdParam
}
if { [lsearch [interp hidden] rmp400SetCmdParamFormatOutput] >= 0 } {
    interp expose {} rmp400SetCmdParamFormatOutput
}

proc ::rmp400SetCmdParam { name args } {
    set format {}
    lappend format [list double "cmd.distPoint" 0.0 ]
    lappend format [list double "cmd.KpLongit" 0.0 ]
    lappend format [list double "cmd.KiLongit" 0.0 ]
    lappend format [list double "cmd.KpTransv" 0.0 ]
    lappend format [list double "cmd.KiTransv" 0.0 ]
    lappend format [list double "cmd.KpAng" 0.0 ]
    lappend format [list double "cmd.KiAng" 0.0 ]
    lappend format [list double "cmd.longitErrorMax" 0.0 ]
    lappend format [list double "cmd.transvErrorMax" 0.0 ]
    lappend format [list double "cmd.longitMaxErrSum" 0.0 ]
    lappend format [list double "cmd.transvMaxErrSum" 0.0 ]
    lappend format [list double "cmd.angErrorMax" 0.0 ]
    lappend format [list double "cmd.angMaxErrSum" 0.0 ]
    lappend format [list double "cmd.longitMaxGap" 0.0 ]
    lappend format [list double "cmd.transvMaxGap" 0.0 ]
    lappend format [list double "cmd.angMaxGap" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCmdParam" \
	"Set command parameters" \
	"GENPOS_CART_CMD_PARAM\n| double distPoint\n| double KpLongit\n| double KiLongit\n| double KpTransv\n| double KiTransv\n| double KpAng\n| double KiAng\n| double longitErrorMax\n| double transvErrorMax\n| double longitMaxErrSum\n| double transvMaxErrSum\n| double angErrorMax\n| double angMaxErrSum\n| double longitMaxGap\n| double transvMaxGap\n| double angMaxGap\n" \
	16 \
	$format \
	$args ]
}


proc ::rmp400SetCmdParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400SetCmdParam
interp hide {} rmp400SetCmdParamFormatOutput





# SetKinematicsParam ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400SetKinematicsParam] >= 0 } {
    interp expose {} rmp400SetKinematicsParam
}
if { [lsearch [interp hidden] rmp400SetKinematicsParamFormatOutput] >= 0 } {
    interp expose {} rmp400SetKinematicsParamFormatOutput
}

proc ::rmp400SetKinematicsParam { name args } {
    set format {}
    lappend format [list double "kinematics.leftWheelRadius" 0.0 ]
    lappend format [list double "kinematics.rightWheelRadius" 0.0 ]
    lappend format [list double "kinematics.axisWidth" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetKinematicsParam" \
	"Sect Kinematic parameters" \
	"RMP400_KINEMATICS_STR\n| double leftWheelRadius\n| double rightWheelRadius\n| double axisWidth\n" \
	3 \
	$format \
	$args ]
}


proc ::rmp400SetKinematicsParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400SetKinematicsParam
interp hide {} rmp400SetKinematicsParamFormatOutput





# SetVarParam ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400SetVarParam] >= 0 } {
    interp expose {} rmp400SetVarParam
}
if { [lsearch [interp hidden] rmp400SetVarParamFormatOutput] >= 0 } {
    interp expose {} rmp400SetVarParamFormatOutput
}

proc ::rmp400SetVarParam { name args } {
    set format {}
    lappend format [list double "varParams.coeffLin" 0.0 ]
    lappend format [list double "varParams.coeffAng" 0.0 ]
    lappend format [list double "varParams.coeffLinAng" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetVarParam" \
	"Set Parameters of the uncertainty evaluation" \
	"RMP400_VAR_PARAMS\n| double coeffLin\n| double coeffAng\n| double coeffLinAng\n" \
	3 \
	$format \
	$args ]
}


proc ::rmp400SetVarParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400SetVarParam
interp hide {} rmp400SetVarParamFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400Stop] >= 0 } {
    interp expose {} rmp400Stop
}
if { [lsearch [interp hidden] rmp400StopFormatOutput] >= 0 } {
    interp expose {} rmp400StopFormatOutput
}

proc ::rmp400Stop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"Stop any on-going motion" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp400StopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400Stop
interp hide {} rmp400StopFormatOutput





# JoystickOn ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400JoystickOn] >= 0 } {
    interp expose {} rmp400JoystickOn
}
if { [lsearch [interp hidden] rmp400JoystickOnFormatOutput] >= 0 } {
    interp expose {} rmp400JoystickOnFormatOutput
}

proc ::rmp400JoystickOn { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "JoystickOn" \
	"Activate joystick motion mode" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp400JoystickOnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400JoystickOn
interp hide {} rmp400JoystickOnFormatOutput





# Track ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400Track] >= 0 } {
    interp expose {} rmp400Track
}
if { [lsearch [interp hidden] rmp400TrackFormatOutput] >= 0 } {
    interp expose {} rmp400TrackFormatOutput
}

proc ::rmp400Track { name args } {
    set format {}
    lappend format [list string "trackParams.posterName.name" "" ]
    lappend format [list { "GENPOS_TRACK_TRAILER" "GENPOS_TRACK_SPEED" "GENPOS_TRACK_CONFIG" "GENPOS_TRACK_POS" "GENPOS_NO_TRACKING" } "trackParams.mode" "" ]

    return [ ::cs::rqstSend "${name}" "Track" \
	"Start tracking a reference poster" \
	"RMP400_TRACK_PARAMS\n| GENPOS_POSTER_NAME\n| | char name\[32\]\n| GENPOS_TRACK_MODE mode\n" \
	2 \
	$format \
	$args ]
}


proc ::rmp400TrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400Track
interp hide {} rmp400TrackFormatOutput





# SetPom ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400SetPom] >= 0 } {
    interp expose {} rmp400SetPom
}
if { [lsearch [interp hidden] rmp400SetPomFormatOutput] >= 0 } {
    interp expose {} rmp400SetPomFormatOutput
}

proc ::rmp400SetPom { name args } {
    set format {}
    lappend format [list string "mePosterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "SetPom" \
	"Define the name of the global POM poster" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp400SetPomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400SetPom
interp hide {} rmp400SetPomFormatOutput





# SetPos ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400SetPos] >= 0 } {
    interp expose {} rmp400SetPos
}
if { [lsearch [interp hidden] rmp400SetPosFormatOutput] >= 0 } {
    interp expose {} rmp400SetPosFormatOutput
}

proc ::rmp400SetPos { name args } {
    set format {}
    lappend format [list double "setPosStr.x" 0.0 ]
    lappend format [list double "setPosStr.y" 0.0 ]
    lappend format [list double "setPosStr.z" 0.0 ]
    lappend format [list double "setPosStr.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetPos" \
	"** undocumented **" \
	"RMP400_CART_3DCONFIG\n| double x\n| double y\n| double z\n| double theta\n" \
	4 \
	$format \
	$args ]
}


proc ::rmp400SetPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400SetPos
interp hide {} rmp400SetPosFormatOutput





# Gyro ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400Gyro] >= 0 } {
    interp expose {} rmp400Gyro
}
if { [lsearch [interp hidden] rmp400GyroFormatOutput] >= 0 } {
    interp expose {} rmp400GyroFormatOutput
}

proc ::rmp400Gyro { name args } {
    set format {}
    lappend format [list { "RMP400_GYRO_ON" "RMP400_GYRO_ON_IF_MOTION" "RMP400_GYRO_OFF" } "params.mode" "" ]
    lappend format [list string "params.port" "" ]
    lappend format [list { "GYRO_KVH_DSP_3000" "GYRO_KVH_DSP_5000" "GYRO_KVH_ECORE_1000" "GYRO_UNKNOWN" } "params.type" "" ]
    lappend format [list double "params.latitude" 0.0 ]
    lappend format [list double "params.woffset" 0.0 ]

    return [ ::cs::rqstSend "${name}" "Gyro" \
	"Gyro configuration" \
	"RMP400_GYRO_PARAMS\n| RMP400_GYRO_MODE mode\n| char port\[32\]\n| GYRO_TYPE type\n| double latitude\n| double woffset\n" \
	5 \
	$format \
	$args ]
}


proc ::rmp400GyroFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400Gyro
interp hide {} rmp400GyroFormatOutput





# GetGyro ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400GetGyro] >= 0 } {
    interp expose {} rmp400GetGyro
}
if { [lsearch [interp hidden] rmp400GetGyroFormatOutput] >= 0 } {
    interp expose {} rmp400GetGyroFormatOutput
}

proc ::rmp400GetGyro { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetGyro" \
	"Returns gyro parameters" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp400GetGyroFormatOutput { list } {
    set format { {} status { } { params { } mode { } port { } type { } latitude { } woffset } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400GetGyro
interp hide {} rmp400GetGyroFormatOutput





# SetOdometryMethod ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400SetOdometryMethod] >= 0 } {
    interp expose {} rmp400SetOdometryMethod
}
if { [lsearch [interp hidden] rmp400SetOdometryMethodFormatOutput] >= 0 } {
    interp expose {} rmp400SetOdometryMethodFormatOutput
}

proc ::rmp400SetOdometryMethod { name args } {
    set format {}
    lappend format [list { "RMP400_ODO_3D" "RMP400_ODO_2D" } "Odometry Method" "RMP400_ODO_2D" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Attitude Poster Name" "imuAttitudeEstimation" ]

    return [ ::cs::rqstSend "${name}" "SetOdometryMethod" \
	"Odometry Configuration" \
	"RMP400_ODOMETRY_METHOD\n| RMP400_ODOMETRY_MODE mode\n| int unused\n| char attitudePosterName\[64\]\n" \
	3 \
	$format \
	$args ]
}


proc ::rmp400SetOdometryMethodFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400SetOdometryMethod
interp hide {} rmp400SetOdometryMethodFormatOutput





# SetWheelSizeCorrection ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400SetWheelSizeCorrection] >= 0 } {
    interp expose {} rmp400SetWheelSizeCorrection
}
if { [lsearch [interp hidden] rmp400SetWheelSizeCorrectionFormatOutput] >= 0 } {
    interp expose {} rmp400SetWheelSizeCorrectionFormatOutput
}

proc ::rmp400SetWheelSizeCorrection { name args } {
    set format {}
    lappend format [list double "Correction coefficient" 1.050000 ]

    return [ ::cs::rqstSend "${name}" "SetWheelSizeCorrection" \
	"Wheel size correction for odometry" \
	"double wheelSizeCorrection\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp400SetWheelSizeCorrectionFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400SetWheelSizeCorrection
interp hide {} rmp400SetWheelSizeCorrectionFormatOutput





# Log ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400Log] >= 0 } {
    interp expose {} rmp400Log
}
if { [lsearch [interp hidden] rmp400LogFormatOutput] >= 0 } {
    interp expose {} rmp400LogFormatOutput
}

proc ::rmp400Log { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Log" \
	"Log robot configuration and date" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp400LogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400Log
interp hide {} rmp400LogFormatOutput





# StopLog ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400StopLog] >= 0 } {
    interp expose {} rmp400StopLog
}
if { [lsearch [interp hidden] rmp400StopLogFormatOutput] >= 0 } {
    interp expose {} rmp400StopLogFormatOutput
}

proc ::rmp400StopLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLog" \
	"Stop activity Log" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp400StopLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400StopLog
interp hide {} rmp400StopLogFormatOutput





# LogInternalData ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400LogInternalData] >= 0 } {
    interp expose {} rmp400LogInternalData
}
if { [lsearch [interp hidden] rmp400LogInternalDataFormatOutput] >= 0 } {
    interp expose {} rmp400LogInternalDataFormatOutput
}

proc ::rmp400LogInternalData { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "LogInternalData" \
	"Log all the raw data provided by robot" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rmp400LogInternalDataFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400LogInternalData
interp hide {} rmp400LogInternalDataFormatOutput





# StopInternalDataLog ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400StopInternalDataLog] >= 0 } {
    interp expose {} rmp400StopInternalDataLog
}
if { [lsearch [interp hidden] rmp400StopInternalDataLogFormatOutput] >= 0 } {
    interp expose {} rmp400StopInternalDataLogFormatOutput
}

proc ::rmp400StopInternalDataLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopInternalDataLog" \
	"Stop activity LogInternalLog" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rmp400StopInternalDataLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400StopInternalDataLog
interp hide {} rmp400StopInternalDataLogFormatOutput





# Goto ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400Goto] >= 0 } {
    interp expose {} rmp400Goto
}
if { [lsearch [interp hidden] rmp400GotoFormatOutput] >= 0 } {
    interp expose {} rmp400GotoFormatOutput
}

proc ::rmp400Goto { name args } {
    set format {}
    lappend format [list int "ref.numRef" 0 ]
    lappend format [list int "ref.tickPeriod" 0 ]
    lappend format [list { "GENPOS_POS_AND_SPEED_DATA" "GENPOS_SPEED_DATA" "GENPOS_POS_DATA" } "ref.dataType" "" ]
    lappend format [list { "GENPOS_BACKWARD_MOTION" "GENPOS_FORWARD_MOTION" } "ref.backFlag" "" ]
    lappend format [list double "ref.x" 0.0 ]
    lappend format [list double "ref.y" 0.0 ]
    lappend format [list double "ref.theta" 0.0 ]
    lappend format [list double "ref.v" 0.0 ]
    lappend format [list double "ref.vt" 0.0 ]
    lappend format [list double "ref.w" 0.0 ]
    lappend format [list double "ref.vmax" 0.0 ]
    lappend format [list double "ref.wmax" 0.0 ]
    lappend format [list double "ref.linAccelMax" 0.0 ]
    lappend format [list double "ref.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "Goto" \
	"Set a reference data" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	14 \
	$format \
	$args ]
}


proc ::rmp400GotoFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400Goto
interp hide {} rmp400GotoFormatOutput





# MEPosmePos ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400MEPosmePosPosterRead] >= 0 } {
    interp expose {} rmp400MEPosmePosPosterRead
}
if { [lsearch [interp hidden] rmp400MEPosmePosPosterFormatOutput] >= 0 } {
    interp expose {} rmp400MEPosmePosPosterFormatOutput
}

proc ::rmp400MEPosmePosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosmePos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::rmp400MEPosmePosPosterFormatOutput { list } {
    set format { {} status { } { mePos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400MEPosmePosPosterRead
interp hide {} rmp400MEPosmePosPosterFormatOutput





# OdoRobot ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400OdoRobotPosterRead] >= 0 } {
    interp expose {} rmp400OdoRobotPosterRead
}
if { [lsearch [interp hidden] rmp400OdoRobotPosterFormatOutput] >= 0 } {
    interp expose {} rmp400OdoRobotPosterFormatOutput
}

proc ::rmp400OdoRobotPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot" \
	"GENPOS_CART_STATE\n| double xRef\n| double yRef\n| double xRob\n| double yRob\n| double theta\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::rmp400OdoRobotPosterFormatOutput { list } {
    set format { {} status { } { Robot { } xRef { } yRef { } xRob { } yRob { } theta { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400OdoRobotPosterRead
interp hide {} rmp400OdoRobotPosterFormatOutput





# OdoVar ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400OdoVarPosterRead] >= 0 } {
    interp expose {} rmp400OdoVarPosterRead
}
if { [lsearch [interp hidden] rmp400OdoVarPosterFormatOutput] >= 0 } {
    interp expose {} rmp400OdoVarPosterFormatOutput
}

proc ::rmp400OdoVarPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoVar" \
	"GENPOS_CART_CONFIG_VAR\n| double var\[6\]\n" \
	$args ]
}


proc ::rmp400OdoVarPosterFormatOutput { list } {
    set format { {} status { } { Var { 6 } var } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400OdoVarPosterRead
interp hide {} rmp400OdoVarPosterFormatOutput





# OdoRobot3d ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400OdoRobot3dPosterRead] >= 0 } {
    interp expose {} rmp400OdoRobot3dPosterRead
}
if { [lsearch [interp hidden] rmp400OdoRobot3dPosterFormatOutput] >= 0 } {
    interp expose {} rmp400OdoRobot3dPosterFormatOutput
}

proc ::rmp400OdoRobot3dPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot3d" \
	"RMP400_CART_3DSTATE\n| double xRef\n| double yRef\n| double zRef\n| double xRob\n| double yRob\n| double zRob\n| double theta\n| double pitch\n| double roll\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::rmp400OdoRobot3dPosterFormatOutput { list } {
    set format { {} status { } { Robot3d { } xRef { } yRef { } zRef { } xRob { } yRob { } zRob { } theta { } pitch { } roll { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400OdoRobot3dPosterRead
interp hide {} rmp400OdoRobot3dPosterFormatOutput





# Refref ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400RefrefPosterRead] >= 0 } {
    interp expose {} rmp400RefrefPosterRead
}
if { [lsearch [interp hidden] rmp400RefrefPosterFormatOutput] >= 0 } {
    interp expose {} rmp400RefrefPosterFormatOutput
}

proc ::rmp400RefrefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Refref" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::rmp400RefrefPosterFormatOutput { list } {
    set format { {} status { } { ref { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400RefrefPosterRead
interp hide {} rmp400RefrefPosterFormatOutput





# Statusstatus ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400StatusstatusPosterRead] >= 0 } {
    interp expose {} rmp400StatusstatusPosterRead
}
if { [lsearch [interp hidden] rmp400StatusstatusPosterFormatOutput] >= 0 } {
    interp expose {} rmp400StatusstatusPosterFormatOutput
}

proc ::rmp400StatusstatusPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Statusstatus" \
	"RMP400_STATUS_STR\n| RMP400_MODE rs_mode\n| RMP400_DATA_STR\n| | double pitch_angle\n| | double pitch_rate\n| | double roll_angle\n| | double roll_rate\n| | double lw_velocity\n| | double rw_velocity\n| | double yaw_rate\n| | short int servo_frames\n| | double integrated_left_wheel\n| | double integrated_right_wheel\n| | double integrated_fore_aft\n| | double integrated_yaw\n| | double left_torque\n| | double right_torque\n| | short int operational_mode\n| | short int controller_gain_schedule\n| | double ui_voltage\n| | double powerbase_voltage\n| | double battery_charge\n| | double velocity_command\n| | double turn_command\n" \
	$args ]
}


proc ::rmp400StatusstatusPosterFormatOutput { list } {
    set format { {} status { } { status { } rs_mode { 2 } { rs_data { } pitch_angle { } pitch_rate { } roll_angle { } roll_rate { } lw_velocity { } rw_velocity { } yaw_rate { } servo_frames { } integrated_left_wheel { } integrated_right_wheel { } integrated_fore_aft { } integrated_yaw { } left_torque { } right_torque { } operational_mode { } controller_gain_schedule { } ui_voltage { } powerbase_voltage { } battery_charge { } velocity_command { } turn_command } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400StatusstatusPosterRead
interp hide {} rmp400StatusstatusPosterFormatOutput





# StatusGenericstatusgen ----------------------------------------------------------

if { [lsearch [interp hidden] rmp400StatusGenericstatusgenPosterRead] >= 0 } {
    interp expose {} rmp400StatusGenericstatusgenPosterRead
}
if { [lsearch [interp hidden] rmp400StatusGenericstatusgenPosterFormatOutput] >= 0 } {
    interp expose {} rmp400StatusGenericstatusgenPosterFormatOutput
}

proc ::rmp400StatusGenericstatusgenPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "StatusGenericstatusgen" \
	"RMP_STATUS_STR\n| double receive_date\n| RMP_MODEL rmp_model\n| RMP400_MODE rs_mode\n| double propulsion_battery_level\n| double aux_battery_level\n| double pitch\n| double roll\n| double yaw_rate\n| double v\n| double w\n| double v_target\n| double w_target\n| float right_front_vel\n| float left_front_vel\n| float right_rear_vel\n| float left_rear_vel\n| float right_front_pos\n| float left_front_pos\n| float right_rear_pos\n| float left_rear_pos\n| float right_front_torque\n| float left_front_torque\n| float right_rear_torque\n| float left_rear_torque\n" \
	$args ]
}


proc ::rmp400StatusGenericstatusgenPosterFormatOutput { list } {
    set format { {} status { } { statusgen { } receive_date { } rmp_model { } rs_mode { } propulsion_battery_level { } aux_battery_level { } pitch { } roll { } yaw_rate { } v { } w { } v_target { } w_target { } right_front_vel { } left_front_vel { } right_rear_vel { } left_rear_vel { } right_front_pos { } left_front_pos { } right_rear_pos { } left_rear_pos { } right_front_torque { } left_front_torque { } right_rear_torque { } left_rear_torque } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rmp400StatusGenericstatusgenPosterRead
interp hide {} rmp400StatusGenericstatusgenPosterFormatOutput


